/****************************************************************/
/*   NOISE GENERATION ROUTINES USING THE			*/
/*   WE(R) DSP16 DIGITAL SIGNAL PROCESSOR			*/
/*   November, 1988 Doc# AP88-18DMOS				*/
/****************************************************************/
/*	 Copyright (c) 1988 AT&T -- All Rights Reserved		*/
/*   WE is a registered trademark of AT&T. AT&T reserves the	*/
/*   right to make changes to  the software described herein	*/
/*   without notice.  No liability is assumed as a result of	*/
/*   their  use or  application.  No rights under any patent	*/
/*   accompany the sale of product.				*/
/****************************************************************/
/*								*/
/*			gaussn4.s				*/
/*								*/
/* This program segment uses table look-up to generate		*/
/* Gaussian distributed deviates				*/

/* ram declarations */
.ram
oldpr:	int	/* old program return value	*/
sign:	int	/* sign of deviate		*/
gret:	int	/* Gaussian deviate		*/
.endram

gdev0:
	/* save program return register for calling routine */
			r1=oldpr
			*r1++=pr			/* save pr  */

		/* get uniform deviate	*/
  call unif0	/* calculate udev from program segment 3 */

  /* manipulate returned value for index */
	r1=sign
	r3=udev
	pt=gdevt

	y=1					/* pre-load if pos	*/
	a1=y

	y=*r3					/* get unif		*/
	a0=y
	y=0xffff				/* set y -		*/
  if mi a1=y					/* if mi, load fs	*/
	*r1=a1

	/* get the next four bits */
	y=0xf
	a0=a0<<1
	a0=a0>>4
	a0=a0>>8				/* next four bits	*/
	a0=a0&y
	i=a0					/* load index		*/
			y=*r1	x=*pt++i	/* incr pt		*/
			y=*r1++ x=*pt++		/* get real		*/
		p=x*y				/* y has sign		*/
	a0=p
	a0=a0<<16
	*r1--=a0				/* return		*/
	/* restore pr */
	*r1--=a0				/* just for --		*/
	pr=*r1
	return

#include "random3.s"	/* text has pseg3.s */

gdevt:
			/*  x value	y value		*/
	int   348	/*  0.015622	0.039368	*/
	int   1040	/*  0.046866	0.117493	*/
	int   1743	/*  0.078109	0.196838	*/
	int   2456	/*  0.109353	0.277405	*/
	int   3186	/*  0.140597	0.359802	*/
	int   3943	/*  0.171841	0.445251	*/
	int   4721	/*  0.203084	0.533142	*/
	int   5543	/*  0.234328	0.625916	*/
	int   6413	/*  0.265572	0.724182	*/
	int   7353	/*  0.296816	0.830383	*/
	int   8380	/*  0.328059	0.946350	*/
	int   9537	/*  0.359303	1.076965	*/
	int   10888	/*  0.390547	1.229553	*/
	int   12548	/*  0.421791	1.416931	*/
	int   14834	/*  0.453034	1.675110	*/
	int   19050	/*  0.484278	2.151184	*/

/* end of file */
