/****************************************************************/
/*   NOISE GENERATION ROUTINES USING THE			*/
/*   WE(R) DSP16 DIGITAL SIGNAL PROCESSOR			*/
/*   November, 1988 Doc# AP88-18DMOS				*/
/****************************************************************/
/*	 Copyright (c) 1988 AT&T -- All Rights Reserved		*/
/*   WE is a registered trademark of AT&T. AT&T reserves the	*/
/*   right to make changes to  the software described herein	*/
/*   without notice.  No liability is assumed as a result of	*/
/*   their  use or  application.  No rights under any patent	*/
/*   accompany the sale of product.				*/
/****************************************************************/
/*								*/
/*			gaussn5.s				*/
/*								*/
/* This program segment uses table look-up to generate		*/
/* Gaussian distributed deviates. The value returned is a	*/
/* random interpolation between two table entries.		*/

/* ram declarations */
.ram
oldpr:	int	/* old program return value			*/
sign:	int	/* sign of deviate				*/
gret:	int	/* Gaussian deviate, and lo value from table	*/
diff:	int	/* difference between lo and high		*/
.endram

gdev0:
	/* save program return register for calling routine */
	r1=oldpr
	*r1++=pr				/* save pr		*/

		/* get uniform deviate	*/
  call unif0	/* calculate udev from program segment 3 */

  /* manipulate returned value for index */
	r1=sign
	r3=udev
	pt=gdevt

	y=1					/* pre-load if pos	*/
	a1=y

	y=*r3					/* get unif		*/
	a0=y
	y=0xffff				/* set y -		*/
  if mi a1=y					/* if mi, load fs	*/
	*r1++=a1				/* store sign		*/

	/* get the next few bits */
	y=0xf
	a0=a0<<1
	a0=a0>>4
	a0=a0>>8				/* next four bits	*/
	a0=a0&y
	i=a0					/* load index		*/

	/* get the lo-end and hi-end of the segment, and get diff */
			y=*r1	x=*pt++i	/* incr pt		*/
			y=*r1	x=*pt++		/* get real		*/
			y=0x1
		p=x*y				/* p=lo val		*/
	a0=p
			y=*r1	x=*pt++		/* x=hi val		*/
			y=0x1
		p=x*y				/* p=hi val		*/
	a1=a0-p					/* a1 = -diff		*/
	*r1++=a0l				/* hold lo		*/
	*r1=a1l					/* hold diff		*/

  /* get second deviate */
  call unif0	/* calculate udev	*/
	r1=diff
	a0=a0>>8				/* 8 bits		*/
	y=0xff					/* mask			*/
	a0=a0&y
	x=a0					/* x=8-bit ran num	*/

  /* scale diff by 2nd deviate, add to lo  */
			y=*r1--			/* y = -diff		*/
		p=x*y	y=*r1--			/* p=scl_y y=lo		*/
	a0=p
	a0=a0<<8				/* scl to diff		*/
	a0=a0-y					/* a0=-lo-scl*diff	*/
	a1=-a0					/* change sign		*/
				x=a1
			y=*r1++			/* y=sign		*/
		p=x*y				/* add sign		*/
	a0=p
	a0=a0<<16				/* scale up		*/
	*r1--=a0
	/* restore pr */
	y=*r1--					/* just to dec r1	*/
	pr=*r1
	return

#include "random3.s"	/* text has pseg3.s */

gdevt:
			/*  x value	y value		*/
	int   0		/*  0.000000	0.000000	*/
	int   694	/*  0.031244	0.078430	*/
	int   1391	/*  0.062488	0.157166	*/
	int   2099	/*  0.093731	0.237122	*/
	int   2818	/*  0.124975	0.318298	*/
	int   3559	/*  0.156219	0.401917	*/
	int   4326	/*  0.187463	0.488586	*/
	int   5126	/*  0.218706	0.578918	*/
	int   5970	/*  0.249950	0.674133	*/
	int   6872	/*  0.281194	0.776062	*/
	int   7856	/*  0.312438	0.887146	*/
	int   8942	/*  0.343681	1.009827	*/
	int   10186	/*  0.374925	1.150208	*/
	int   11667	/*  0.406169	1.317444	*/
	int   13580	/*  0.437413	1.533508	*/
	int   16483	/*  0.468656	1.861267	*/
	int   32767	/*  0.499900	3.700000	*/

/* end of file */
