/****************************************************************/
/*   NOISE GENERATION ROUTINES USING THE			*/
/*   WE(R) DSP16 DIGITAL SIGNAL PROCESSOR			*/
/*   November, 1988 Doc# AP88-18DMOS				*/
/****************************************************************/
/*	 Copyright (c) 1988 AT&T -- All Rights Reserved		*/
/*   WE is a registered trademark of AT&T. AT&T reserves the	*/
/*   right to make changes to  the software described herein	*/
/*   without notice.  No liability is assumed as a result of	*/
/*   their  use or  application.  No rights under any patent	*/
/*   accompany the sale of product.				*/
/****************************************************************/
/*								*/
/*			iir6.s					*/
/*								*/
/* This program segment implements an IIR filter to filter	*/
/* a random number sequence. The spectrum of the filtered	*/
/* sequence will be low-passed filtered, with a cutoff		*/
/* frequency of 0.1 times the sampling rate. This program	*/
/* segment assumes that the SAT field in the AUC is enabled.	*/

/* ram declarations */
.ram
oldpr:	int	/* old program return value		*/
fret:	int	/* old filtered signal and new one	*/
.endram

fdev:
  /* save program return register for calling routine	*/
	r1=oldpr
	*r1++=pr				/* save pr		*/

  /* get uniform deviate from program segment 3 */
  call unif0

  /* get old value, scale down, filter and add on new deviate */
	pt=alpha
	r2=udev					/* for unif0		*/
			y=*r1	x=*pt++
		p=x*y				/* multiply		*/
	a1=p		y=*r2			/* y=new rv		*/

	a0=a0>>1				/* a0 from unif0	*/
	a0=a0>>1
			y=a0
	a1=a1+y					/* now filtered		*/
	a1=a1<<1				/* shift to nom.	*/
	a1=a1<<1
	*r1=a1

	/* restore pr */
	y=*r1--					/* just to dec r1	*/
	pr=*r1
	return

alpha:	int  1.414	/* alpha = .707, determines corner */
			/* set to 1.414 for scaling        */

#include "random3.s"	/* "pseg3.s" in text */

/* end of file */

