/****************************************************************/
/*   NOISE GENERATION ROUTINES USING THE			*/
/*   WE(R) DSP16 DIGITAL SIGNAL PROCESSOR			*/
/*   November, 1988 Doc# AP88-18DMOS				*/
/****************************************************************/
/*	 Copyright (c) 1988 AT&T -- All Rights Reserved		*/
/*   WE is a registered trademark of AT&T. AT&T reserves the	*/
/*   right to make changes to  the software described herein	*/
/*   without notice.  No liability is assumed as a result of	*/
/*   their  use or  application.  No rights under any patent	*/
/*   accompany the sale of product.				*/
/****************************************************************/
/*								*/
/*			mktab4.c				*/
/*								*/
/* This program repeatedly calls function errfinv() to generate	*/
/* the contents of a Table 4. The output is usable as DSP16	*/
/* assembly code.						*/

main(argc,argv)
int argc;
char *argv[];
{
	double errfinv();
	int nints;	/* number of intervals */
	int i;
	float xval, xval0, xincr;
	float xmax, ymax;
	float yval;
	float tmp;
	int ival, iscl;

	if ( argc == 1 )
	{
	    print("needs an integer argument");
	    exit();
	}

	scanf(argv[1]," %d", &nints);	/* get number of intervals	*/
/*	printf(" nints = %d", nints); */
	
	xmax = .49;		/* not to .5; need to limit yvals to 3.7 */
	ymax = 3.7;
	iscl = 1024*32 - 1;	/* scale to 2^15-1			*/

	xincr = xmax/nints;	/* set increment			*/
	xval0 = xincr/2;	/* set sttarting value			*/
	printf("");
	printf("		gdevt:");
	printf("		/* This table is for use with Program Segment 4 */");
	printf("				/*x-value	y-value*/");

	for ( i=0; i < nints; i++ )
	{
	    xval = xval0 + i*xincr;	/* mid point of interval i	*/
	    tmp = errfinv(xval, &yval);
	    ival = (yval/ymax)*iscl;
	    printf("	int	%d	/*%f	%f*/", ival, xval, yval);
	}
	printf("/*			Table 4	*/");
}
/* end of file */
